
/* this is derived from jktrans.c, therefore this source code has many
   unnecessary parts. sorry, I am so busy nowadays. by ohhara */

#include <windows.h>
#include <string.h>

#define OTHEXPORT __declspec(dllexport)

#include "oh_trmod.h"
#include "ohbbhlp.h"

#define BUFFSIZE 8192
#define OTHPATHLEN 2048

#define OTHLOCKINIT() InitializeCriticalSection(&CriticalSection)
#define OTHLOCK() EnterCriticalSection(&CriticalSection)
#define OTHUNLOCK() LeaveCriticalSection(&CriticalSection)
#define OTHLOCKDEL() DeleteCriticalSection(&CriticalSection)

static const OHBSETTING *pTransSetting;
static HINSTANCE hInst;
static HMODULE hBabel;
static int isRunning;

static CRITICAL_SECTION CriticalSection;
static char utfjpbuff[BUFFSIZE];
static int utfjpendpos;
static char euckrbuff[BUFFSIZE];
static int euckrendpos;
static HANDLE jktrth;

static char *OthJKTrans(char *utfjp);
static void OthPushUTFJP(char *utfjp, int len);
static char *OthPullUTFJP(void);
static void OthPushEUCKR(char *euckr);
static char *OthPullEUCKR(void);

static void OthJKTransThread(void *arg);

static int (OHBCALL *pfnOhbInit)(OHBTRANSID iTransID);
static void (OHBCALL *pfnOhbDestroy)(OHBTRANSID iTransID);
static const OHBSETTING * (OHBCALL *pfnOhbGetSettings)(int *piSetting);
static const OHBTRANS * (OHBCALL *pfnOhbTrans)(LPCWSTR jpStr,
  const OHBSETTING *pSetting);
static void (OHBCALL *pfnOhbFree)(const OHBTRANS *ohbTrans);

static char *OthJKTrans(char *utfjp)
{
  int len;
  LPWSTR jpStr;
  char *krStr;
  const OHBTRANS *tr;

  len = MultiByteToWideChar(65001, 0, utfjp, -1, 0, 0);
  jpStr = malloc(len * 2);
  MultiByteToWideChar(65001, 0, utfjp, -1, jpStr, len);

  tr = pfnOhbTrans(jpStr, pTransSetting);

  len = WideCharToMultiByte(949, 0, tr->lpStr, -1, 0, 0, 0, 0);
  krStr = malloc(len);
  WideCharToMultiByte(949, 0, tr->lpStr, -1, krStr, len, 0, 0);

  pfnOhbFree(tr);

  free(jpStr);

  return krStr;
}

static void OthPushUTFJP(char *utfjp, int len)
{
  int i;

  if (len <= 0)
    return;

  OTHLOCK();

  if (utfjpendpos >= BUFFSIZE)
  {
    utfjpbuff[0] = '\0';
    utfjpendpos = 0;
  }

  for (i = 0; i < len && utfjpendpos < BUFFSIZE && utfjp[i] != '\0';
    ++i, ++utfjpendpos)
  {
    utfjpbuff[utfjpendpos] = utfjp[i];
  }

  if (utfjpendpos >= BUFFSIZE)
  {
    utfjpbuff[0] = '\0';
    utfjpendpos = 0;
  }

  utfjpbuff[utfjpendpos] = '\0';

  OTHUNLOCK();
}

static const char *delimiters[] =
  {
    "\x21",
    "\x22",
    "\x27",
    "\x28",
    "\x29",
    "\x2c",
    "\x2e",
    "\x3a",
    "\x3b",
    "\x3c",
    "\x3e",
    "\x3f",
    "\x5b",
    "\x5d",
    "\x5e",
    "\x60",
    "\x7b",
    "\x7d",
    "\xc2\xab",
    "\xc2\xbb",
    "\xc2\xb4",
    "\xc2\xb7",
    "\xc2\xb8",
    "\xe3\x80\x81",
    "\xe3\x80\x82",
    "\xef\xbc\x8c",
    "\xef\xbc\x8e",
    "\xe3\x83\xbb",
    "\xef\xbc\x9a",
    "\xef\xbc\x9b",
    "\xef\xbc\x9f",
    "\xef\xbc\x81",
    "\xe3\x82\x9b",
    "\xe3\x82\x9c",
    "\xc2\xb4",
    "\xef\xbd\x80",
    "\xc2\xa8",
    "\xef\xbc\xbe",
    "\xe2\x80\x98",
    "\xe2\x80\x99",
    "\xe2\x80\x9c",
    "\xe2\x80\x9d",
    "\xef\xbc\x88",
    "\xef\xbc\x89",
    "\xe3\x80\x94",
    "\xe3\x80\x95",
    "\xef\xbc\xbb",
    "\xef\xbc\xbd",
    "\xef\xbd\x9b",
    "\xef\xbd\x9d",
    "\xe3\x80\x88",
    "\xe3\x80\x89",
    "\xe3\x80\x8a",
    "\xe3\x80\x8b",
    "\xe3\x80\x8c",
    "\xe3\x80\x8d",
    "\xe3\x80\x8e",
    "\xe3\x80\x8f",
    "\xe3\x80\x90",
    "\xe3\x80\x91",
    "\xef\xbc\x9c",
    "\xef\xbc\x9e",
    "\xe2\x80\xb2",
    "\xe2\x80\xb3",
    "\xe2\x89\xaa",
    "\xe2\x89\xab",
    "\xe2\x80\xa6",
    "\xe2\x80\x9a",
    "\xe2\x80\x9e",
    "\xcb\x86",
    "\xe2\x80\xb9",
    "\xe2\x80\x98",
    "\xe2\x80\x99",
    "\xe2\x80\x9c",
    "\xe2\x80\x9d",
    "\xe2\x80\xa2",
    "\xe2\x80\xba",
    "\xef\xbd\xa2",
    "\xef\xbd\xa3",
    "\xbd\xa4"
  };
static const int ndelimiters = sizeof(delimiters) / sizeof(char *);

static char *OthPullUTFJP(void)
{
  int dpos, newdpos, i, delfound;
  char *newdposptr;
  char *retutfjp;

  OTHLOCK();

  if (utfjpendpos == 0)
  {
    OTHUNLOCK();
    return NULL;
  }

  for (i = 0, dpos = utfjpendpos, delfound = 0; i < ndelimiters; i++)
  {
    newdposptr = strstr(utfjpbuff, delimiters[i]);
    if (newdposptr != NULL)
    {
      delfound = 1;
      newdpos = newdposptr - utfjpbuff + strlen(delimiters[i]);
      if (dpos > newdpos)
      {
        dpos = newdpos;
      }
    }
  }

  if (delfound == 0)
  {
    retutfjp = NULL;
  }
  else
  {
    retutfjp = malloc(dpos + 1);
    memcpy(retutfjp, utfjpbuff, dpos);
    retutfjp[dpos] = '\0';
    memmove(utfjpbuff, utfjpbuff + dpos, strlen(utfjpbuff + dpos) + 1);
    utfjpendpos = strlen(utfjpbuff);
  }

  if (retutfjp)
  {
    for (i = 0; i < ndelimiters; i++)
    {
      if (strcmp(delimiters[i], retutfjp) == 0)
      {
        retutfjp[0] = '\0';
        break;
      }
    }
  }

  OTHUNLOCK();

  return retutfjp;
}

static void OthPushEUCKR(char *euckr)
{
  int i, len;

  if (euckr == NULL)
    return;

  len = strlen(euckr);

  OTHLOCK();

  if (euckrendpos >= BUFFSIZE)
  {
    euckrbuff[0] = '\0';
    euckrendpos = 0;
  }

  for (i = 0; i < len && euckrendpos < BUFFSIZE; ++i, ++euckrendpos)
  {
    euckrbuff[euckrendpos] = euckr[i];
  }

  if (euckrendpos >= BUFFSIZE)
  {
    euckrbuff[0] = '\0';
    euckrendpos = 0;
  }

  euckrbuff[euckrendpos] = '\0';

  OTHUNLOCK();
}

static char *OthPullEUCKR(void)
{
  char *ret = NULL;

  OTHLOCK();

  if (euckrendpos != 0)
  {
    ret = strdup(euckrbuff);
    euckrbuff[0] = '\0';
    euckrendpos = 0;
  }

  OTHUNLOCK();

  return ret;
}

static void OthJKTransThread(void *arg)
{
  char *utfjp;
  char *euckr;

  while (isRunning)
  {
    utfjp = OthPullUTFJP();
    if (utfjp != NULL)
    {
      if (utfjp[0] != '\0')
      {
        euckr = OthJKTrans(utfjp);
        OthPushEUCKR(euckr);
        free(euckr);
      }
      free(utfjp);
    }
    else
    {
      Sleep(500);
    }
  }
}

OTHEXPORT int OTHCALL OthTransInit(OTHTR *pTR)
{
  int i;
  const OHBSETTING *arrSettings;

  if (isRunning)
  {
    ++isRunning;
    return 0;
  }

  if (pfnOhbInit(OHBID_BABEL_JK) != 0)
  {
    return -1;
  }

  arrSettings = pfnOhbGetSettings(&i);
  if ((i < OHBID_BABEL_JK) ||
    (arrSettings[OHBID_BABEL_JK].iTransID == OHBID_INVALID))
  {
    pfnOhbDestroy(OHBID_BABEL_JK);
    return -2;
  }

  pTransSetting = &arrSettings[OHBID_BABEL_JK];

  pTR->lpStr = NULL;
  pTR->iLen = 0;

  OTHLOCKINIT();

  isRunning = 1;

  jktrth = (HANDLE)_beginthread(&OthJKTransThread, 0, NULL);

  return 0;
}

OTHEXPORT int OTHCALL OthTransSetting(OTHTR *pTR)
{
  return 0;
}

OTHEXPORT int OTHCALL OthTransCopySetting(OTHTR *pDestTR, OTHTR *pSrcTR)
{
  return 0;
}

OTHEXPORT int OTHCALL OthTranslate(OTHTR *pTR, LPCWSTR lpStr, int iLen)
{
  int len;
  LPSTR euckr;

  if (lpStr[0] != 0)
  {
    LPSTR utfjp;
    len = WideCharToMultiByte(CP_UTF8, 0, lpStr, iLen, 0, 0, 0, 0);
    utfjp = _alloca(len);
    WideCharToMultiByte(CP_UTF8, 0, lpStr, iLen, utfjp, len, 0, 0);
    OthPushUTFJP(utfjp, len);
  }

  euckr = OthPullEUCKR();

  free(pTR->lpStr);
  pTR->lpStr = NULL;

  if (euckr)
  {
    len = MultiByteToWideChar(949, 0, euckr, -1, 0, 0);
    pTR->lpStr = malloc(len << 1);
    MultiByteToWideChar(949, 0, euckr, -1, pTR->lpStr, len);
    pTR->iLen = lstrlenW(pTR->lpStr);
  }

  if (pTR->lpStr == NULL)
  {
    pTR->lpStr = malloc(2);
    pTR->lpStr[0] = 0;
    pTR->iLen = 0;
  }

  return 0;
}

OTHEXPORT int OTHCALL OthTransDestroy(OTHTR *pTR)
{
  --isRunning;
  if (isRunning != 0)
    return 0;

  if (jktrth)
  {
    WaitForSingleObject(jktrth, INFINITE);
    jktrth = NULL;
  }
  utfjpbuff[0] = '\0';
  utfjpendpos = 0;
  euckrbuff[0] = '\0';
  euckrendpos = 0;
  OTHLOCKDEL();
  free(pTR->lpStr);
  pfnOhbDestroy(OHBID_BABEL_JK);

  return 0;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{

  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:
      hInst = hinstDLL;
      {
        int i, len, bslash = 1;
        TCHAR path[OTHPATHLEN];
        GetModuleFileName(hInst, path, OTHPATHLEN);
        len = lstrlen(path);
        if (len > 2000)
        {
          return FALSE;
        }
        for (i = len - 1; i > 0; --i)
        {
          if (path[i] == (TCHAR)'\\')
          {
            if (bslash)
            {
              --bslash;
            }
            else
            {
              break;
            }
          }
        }
        if (i < 0)
        {
          return FALSE;
        }
        path[i] = (TCHAR)'\0';
        lstrcat(path, TEXT("\\ohbbhlp.dll"));
        printf("%S\n", path);
        hBabel = LoadLibrary(path);
        if (hBabel == NULL)
        {
          return FALSE;
        }
        pfnOhbInit = (PVOID)GetProcAddress(hBabel, "OhbInit");
        if (pfnOhbInit == NULL)
        {
          return FALSE;
        }
        pfnOhbDestroy = (PVOID)GetProcAddress(hBabel, "OhbDestroy");
        if (pfnOhbDestroy == NULL)
        {
          return FALSE;
        }
        pfnOhbGetSettings = (PVOID)GetProcAddress(hBabel, "OhbGetSettings");
        if (pfnOhbGetSettings == NULL)
        {
          return FALSE;
        }
        pfnOhbTrans = (PVOID)GetProcAddress(hBabel, "OhbTrans");
        if (pfnOhbTrans == NULL)
        {
          return FALSE;
        }
        pfnOhbFree = (PVOID)GetProcAddress(hBabel, "OhbFree");
        if (pfnOhbFree == NULL)
        {
          return FALSE;
        }
      }
      break;

    case DLL_PROCESS_DETACH:
      FreeLibrary(hBabel);
      break;
  }

  return TRUE;
}
