// programmed by nightknight ( webmaster@mystictales.net )

library jkeztrans;

//{$DEFINE DEBUG}

{$IFDEF DEBUG}
uses
  SysUtils, Windows, DateUtils;
{$ELSE}
uses
  SysUtils, Windows;
{$ENDIF}

const
  initStr:PChar = 'CSUSER123455';
  delimCount = 7;
  delim : array[0..delimCount-1] of String = (#$81#$9C, #$81#$A5, #$81#$79, #$81#$42, #$81#$75, #$81#$76, #$81#$48);
  delimEnd : array[0..delimCount-1] of Boolean = (false, true, false, true, false, true, true);

type
  TOTHTR = packed record
    pSetting:Pointer;
    pStr:PWideChar;
    nLen:Integer;
    reserved:array[0..23] of Byte;
  end;
  POTHTR = ^TOTHTR;

var dllHandle:THandle;
  fnTranslate, fnFreeMem:TFarProc;
  stBuf, stText:String;
  bTrans:Boolean;

{$IFDEF DEBUG}
var
  fDbg1, fDbg2, fDbg3:Boolean;

procedure DebugPrint(pStr:PChar; nLen:Integer);overload;
var fTxt:File;
begin
  AssignFile(fTxt,'c:\jkezdbg.dat');
  if(fDbg1)then begin
    ReWrite(fTxt,1);
    fDbg1 := False;
  end else begin
    Reset(fTxt,1);
    Seek(fTxt, FileSize(fTxt));
  end;
  BlockWrite(fTxt, pStr^, nLen);
  CloseFile(fTxt);
end;

procedure DebugPrint(stLn:String);overload;
var fTxt:TextFile;
begin
  AssignFile(fTxt,'c:\jkezdbg1.txt');
  if(fDbg2)then begin
    ReWrite(fTxt);
    fDbg2 := False;
  end else begin
    Append(fTxt);
  end;
  WriteLn(fTxt, stLn);
  CloseFile(fTxt);
end;

procedure DebugPrint2(stLn:String);overload;
var fTxt:TextFile;
begin
  AssignFile(fTxt,'c:\jkezdbg2.txt');
  if(fDbg3)then begin
    ReWrite(fTxt);
    fDbg3 := False;
  end else begin
    Append(fTxt);
  end;
  WriteLn(fTxt, stLn);
  CloseFile(fTxt);
end;

{$ENDIF}

procedure Translate(stLn:String);
var pSrc:PChar;nResult:Integer;
begin
  if(stLn = '')then exit;
  bTrans := True;
  pSrc := PChar(stLn);
  asm
    push pSrc
    push 0
    call fnTranslate
    mov nResult, eax
  end;
  stText := String(PChar(nResult));
  asm
    push nResult
    call fnFreeMem
  end;
end;

procedure Push(stChar:String);
var i:Integer;
{$IFDEF DEBUG}
  stTime:String;
{$ENDIF}
begin
{$IFDEF DEBUG}
  DateTimeToString(stTime, '[hh:nn:ss.zzz] ', Time);
  DebugPrint2(stTime + stChar);
{$ENDIF}
  if(Length(stChar)>2)then begin
    if(stBuf <> '')then begin
      stBuf := stBuf + #13#10 + stChar;
    end else begin
      stBuf := stChar;
    end;
{$IFDEF DEBUG}
    stBuf := stTime + '[[' + stBuf + ']]';
    DebugPrint(stBuf);
{$ENDIF}
    Translate(stBuf);
    stBuf := '';
  end else begin
    for i:=0 to delimCount-1 do
      if delim[i] = stChar then begin
        if(delimEnd[i])and(stBuf<>'')then stBuf := stBuf + stChar;
{$IFDEF DEBUG}
        stBuf := stTime + stBuf;
        DebugPrint(stBuf);
{$ENDIF}
        Translate(stBuf);
        stBuf := '';
        if(delimEnd[i])then exit;
      end;
    stBuf := stBuf + stChar;
  end;
end;

function RootReplace(stLn:String):String;
var i:Integer;
begin
  Result := '';
  for i:=1 to Length(stLn) do begin
    if(stLn[i] = '\')then
      Result := Result + '\\'
    else
      Result := Result + stLn[i];
  end;
end;

function OthTransInit(pTR:POTHTR):Integer;stdcall;
var nResult:Integer;ProcPtr:TFarProc;
  initPath, pPath:PChar;
  DataType, nBufLen:Longint;
  ezKey:HKEY;
begin
  stBuf:='';stText:='';
  dllHandle := 0;
  Result := -1;

  if(RegOpenKey(HKEY_CURRENT_USER, 'Software\ChangShin\ezTrans', ezKey) = ERROR_SUCCESS)then begin
    DataType := REG_SZ;
    nBufLen := 250;
    GetMem(pPath, nBufLen);
    RegQueryValueEx(ezKey, 'FilePath', nil, @DataType, PByte(pPath), @nBufLen);
    RegCloseKey(ezKey);
  end else begin
    exit;
  end;

  if(not DirectoryExists(pPath))then exit;

  dllHandle := LoadLibrary(PChar(pPath + '\J2KEngine.dll'));
  if(dllHandle = 0)then begin
    FreeMem(pPath);
    exit;
  end;

  ProcPtr := GetProcAddress(DLLHandle, 'J2K_InitializeEx');
  nResult := 0;
  Result := 0;
  initPath := PChar(RootReplace(pPath + '\Dat'));
  if (ProcPtr <> nil)then asm
    push initPath
    push initStr
    call ProcPtr
    mov nResult, eax
  end;
  FreeMem(pPath);

  if(nResult = 1)then begin
    fnTranslate := GetProcAddress(DLLHandle, 'J2K_TranslateMMNT');
    fnFreeMem := GetProcAddress(DLLHandle, 'J2K_FreeMem');
    if(fnTranslate = nil)or(fnFreeMem=nil)then nResult := 0;
  end;
  if(nResult = 0)then begin
    FreeLibrary(dllHandle);
    dllHandle := 0;
    Result := -1;
  end;
end;

function OthTransSetting(pTR:POTHTR):Integer;stdcall;
begin
  Result := 0;
end;

function OthTransCopySetting(pDestTR:POTHTR;pSrcTR:POTHTR):Integer;stdcall;
begin
  Result := 0;
end;

function OthTranslate(pTR:POTHTR;pStr:PWideChar;nLen:Integer):Integer;stdcall;
var pJpn:PChar;nJpnLen, nWideLen:Integer;
begin
  nJpnLen := WideCharToMultiByte(932, 0, pStr, nLen, nil, 0, nil, nil);
  GetMem(pJpn, nJpnLen+1);
  WideCharToMultiByte(932, 0, pStr, nLen, pJpn, nJpnLen, nil, nil);
  PByte(Integer(pJpn) + nJpnLen)^ := 0;
  Push(pJpn);
  FreeMem(pJpn);

  if(pTR^.pStr <> nil)then FreeMem(pTR^.pStr);
  if(bTrans)and(stText <> '')then begin
    stText := stText + #13#10;
    nWideLen := MultiByteToWideChar(949, 0, PChar(stText), Length(stText), nil, 0);
    GetMem(pTR^.pStr, nWideLen*2);
    pTR^.nLen := nWideLen;
    MultiByteToWideChar(949, 0, PChar(stText), Length(stText), pTR^.pStr, pTR^.nLen);
    stText := '';
    bTrans := False;
  end else begin
    GetMem(pTR^.pStr, 2);
    FillChar(pTR^.pStr^, 2, 0);
    pTR^.nLen := 0;
  end;

  Result := 0;
end;

function OthTransDestroy(pTR:POTHTR):Integer;stdcall;
var ProcPtr:TFarProc;
begin
  if(pTR^.pStr <> nil)then FreeMem(pTR^.pStr);
  if(dllHandle <> 0)then begin
    ProcPtr := GetProcAddress(DLLHandle, 'J2K_StopTranslation');
    if (ProcPtr <> nil)then asm
      push 0
      call ProcPtr
    end;
    ProcPtr := GetProcAddress(DLLHandle, 'J2K_Terminate');
    if (ProcPtr <> nil)then asm call ProcPtr end;
    FreeLibrary(dllHandle);
  end;
  dllHandle := 0;
  Result := 0;
end;

exports
  OthTransInit,
  OthTransSetting,
  OthTransCopySetting,
  OthTranslate,
  OthTransDestroy;

begin
  dllHandle := 0;
  bTrans := False;
{$IFDEF DEBUG}
  fDbg1 := True;
  fDbg2 := True;
  fDbg3 := True;
{$ENDIF}
end.
